VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "GDI32: Font aus Ressource oder Fontdatei erstellen."
   ClientHeight    =   5445
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   11625
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5445
   ScaleWidth      =   11625
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   5295
      Left            =   5850
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   3
      Text            =   "Form1.frx":0000
      Top             =   60
      Width           =   5685
   End
   Begin VB.ListBox List1 
      Height          =   2985
      Left            =   60
      Sorted          =   -1  'True
      TabIndex        =   2
      Top             =   1830
      Width           =   5685
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Allle verfgbare und auflistbare Schriften auflisten."
      Height          =   495
      Left            =   60
      TabIndex        =   1
      Top             =   4890
      Width           =   5685
   End
   Begin VB.PictureBox picRes 
      Height          =   1695
      Left            =   60
      ScaleHeight     =   1635
      ScaleWidth      =   5655
      TabIndex        =   0
      Top             =   60
      Width           =   5715
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Enum FontFrom
    FromRes = 0&
    FromFile = 1&
End Enum

Private Type MyFontCollection
    hMemFont As Long
    sFontFile As String
    sFontName As String
    lFontFrom As FontFrom
    lFontFlags As Long
End Type

Private m_FontCollection() As MyFontCollection

Private Sub Form_Load()

    ' Fonts aus der Ressource sind immer FR_PRIVATE Or FR_NOT_ENUM
    'Call LoadFontFromRes(101, "Font", m_FontCollection, "Dingleberries")
    'Call LoadFontFromRes(102, "Font", m_FontCollection, "DSEG14 Classic")
    
    
    ' FR_DEFAULT = Font steht im eigenen Programm und in anderen Programmen zur
    ' Verfgung und ist im eigenen, sowie in anderen Programmen auflistbar.
    ' Sobald dieses Programm aber wieder beendet wird, steht der Font in anderen
    ' Programmen nicht mehr zur Verfgung!!!

    ' FR_PRIVATE = Font steht nur im eigenen Programm zur Verfgung und ist in anderen
    ' Programmen auch nicht auflistbar. Im eigenen Programm lsst sich der Font auflisten.
    
    ' FR_NOT_ENUM = Font steht nur im eigenen Programm zur Verfgung und ist in anderen
    ' und im eigenen Programmen nicht auflistbar.
    
    Call LoadFontFromFile(App.Path & "\Dingleberries.ttf", m_FontCollection, "Dingleberries", FR_DEFAULT)
    Call LoadFontFromFile(App.Path & "\DSEG14Classic.ttf", m_FontCollection, "DSEG14 Classic", FR_PRIVATE Or FR_NOT_ENUM)
    
    ' Einen Text in ein DC zeichnen
    Call DrawText("ABCE", m_FontCollection, "Dingleberries", 40, FontStyleRegular)
    
    ' Font aus der FontCollection verwenden
    Text1.FontSize = 20
    Text1.Text = "Das ist ein Text." _
        & vbNewLine & vbNewLine & "5*7=35"
    
    Text1.FontName = GetFontNameFromIndex(1, m_FontCollection)

End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    Dim lItem As Long
    Dim lCount As Long
    
    ' ist die FontCollection dimensioniert
    If SafeArrayGetDim(m_FontCollection) <> 0& Then
    
        lCount = UBound(m_FontCollection)
        
        For lItem = 0 To lCount
        
            If m_FontCollection(lItem).lFontFrom = FromRes Then
            
                ' Font aus dem Speicher entfernen
                Call RemoveFontMemResourceEx(m_FontCollection(lItem).hMemFont)
            
            Else
            
                ' Font aus dem Speicher entfernen
                Call RemoveFontResourceEx(StrPtr(m_FontCollection(lItem).sFontFile), _
                    m_FontCollection(lItem).lFontFlags, 0&)
            
            End If
        
        Next
    
    End If

End Sub

Private Sub Command1_Click()

    Dim tLOGFONTW As LOGFONTW

    tLOGFONTW.lfCharSet = ANSI_CHARSET

    ' alle Schriftarten auflisten
    Call EnumFontFamiliesEx(Me.hDC, tLOGFONTW, AddressOf EnumFontFamiliesExProc, _
        List1.hWnd, 0&)

End Sub

Private Function LoadFontFromRes(ByVal ResID As Long, ByVal ResType As String, _
    ByRef FontCollection() As MyFontCollection, ByVal FontName As String) As Boolean

    Dim bFont() As Byte
    Dim hMem As Long
    Dim hMemFont As Long
    Dim lNumFonts As Long
    Dim lDataSize As Long
    Dim bolRet As Boolean

    bolRet = False

    ' Font aus der Ressource in ein ByteArray laden
    bFont = LoadResData(ResID, ResType)

    ' ist das ByteArray dimensioniert
    If SafeArrayGetDim(bFont) <> 0& Then

        ' Gre der Daten
        lDataSize = UBound(bFont) + 1

        ' entsprechend groen Speicherbereich festlegen
        hMem = CoTaskMemAlloc(lDataSize)

        ' ist Speicher vorhanden
        If hMem <> 0& Then

            ' ByteArray in den Speicher kopieren
            Call CopyMemory(ByVal hMem, ByVal VarPtr(bFont(0)), lDataSize)

            ' aus im Speicher liegenden Daten einen Font hinzufgen
            hMemFont = AddFontMemResourceEx(hMem, lDataSize, 0&, lNumFonts)

            ' ist ein Font vorhanden
            If hMemFont <> 0& Then

                ' ist die FontCollection dimensioniert
                If SafeArrayGetDim(FontCollection) = 0& Then

                    ' erste Dimensionierung
                    ReDim FontCollection(0)

                Else

                    ' Dimensionierung vergrern
                    ReDim Preserve FontCollection(UBound(FontCollection) + 1)

                End If
                
                ' Font der FontCollection hinzufgen
                With FontCollection(UBound(FontCollection))
                    .hMemFont = hMemFont
                    .lFontFrom = FromRes
                    .lFontFlags = 0&
                    .sFontFile = vbNullString
                    .sFontName = FontName
                End With
                
                bolRet = True

            End If

            ' Speicher wieder freigeben
            Call CoTaskMemFree(hMem)

        End If

    End If

    LoadFontFromRes = bolRet

End Function

Private Function LoadFontFromFile(ByVal FontFile As String, ByRef FontCollection() _
    As MyFontCollection, ByVal FontName As String, Optional ByVal eFlags As _
    FR_FLAGS = FR_DEFAULT) As Boolean

    Dim hMem As Long
    Dim hMemFont As Long
    Dim bolRet As Boolean

    bolRet = False

    ' ist ein String vorhanden
    If Len(FontFile) = 0& Then Exit Function

    ' ist die Datei vorhanden
    If PathFileExistsW(StrPtr(FontFile)) <> 0& Then

        ' Fontdatei in den Speicher laden
        hMemFont = AddFontResourceEx(StrPtr(FontFile), eFlags, 0&)

        ' ist ein Font im Seicher vorhanden
        If hMemFont <> 0& Then

            ' ist die FontCollection dimensioniert
            If SafeArrayGetDim(FontCollection) = 0& Then

                ' erste Dimensionierung
                ReDim FontCollection(0)

            Else

                ' Dimensionierung vergrern
                ReDim Preserve FontCollection(UBound(FontCollection) + 1)

            End If

            ' Font der FontCollection hinzufgen
            With FontCollection(UBound(FontCollection))
                .hMemFont = hMemFont
                .lFontFrom = FromFile
                .lFontFlags = eFlags
                .sFontFile = FontFile
                .sFontName = FontName
            End With

            bolRet = True

        End If

    End If

    LoadFontFromFile = bolRet

End Function

Private Function GetFontNameFromIndex(ByVal lIndex As Long, ByRef _
    aFontCollection() As MyFontCollection) As String

    Dim lCount As Long

    lCount = UBound(aFontCollection)
    
    If lIndex < 0& Then lIndex = 0&
    If lIndex > lCount Then lIndex = lCount
    
    GetFontNameFromIndex = aFontCollection(lIndex).sFontName

End Function

Private Function GetIndexFromFontName(ByVal FontName As Long, ByRef _
    aFontCollection() As MyFontCollection) As Long

    Dim lItem As Long
    Dim lCount As Long
    
    If Len(FontName) = 0& Then Exit Function

    lCount = UBound(aFontCollection)

    ' alle Schriftarten in der FontCollection durchlaufen
    For lItem = 0 To lCount

        ' passt der Name
        If aFontCollection(lItem).sFontName = FontName Then

            ' Font gefunden
            GetIndexFromFontName = lItem

            Exit For

        End If

    Next

End Function

Private Sub DrawText(ByVal sText As String, ByRef aFontCollection() As _
    MyFontCollection, ByVal FontName As String, Optional ByVal FontSize _
    As Long = 10&, Optional ByVal eFontStyle As FontStyle = FontStyleRegular)

    Dim hFont As Long
    Dim lItem As Long
    Dim lCount As Long
    Dim hPrevFont As Long
    Dim sFontName As String
    Dim tLOGFONT As LOGFONTW
    Dim bFontExists As Boolean

    If SafeArrayGetDim(aFontCollection) = 0& Then Exit Sub
    If Len(sText) = 0& Then Exit Sub
    If Len(FontName) = 0& Then Exit Sub

    bFontExists = False
    picRes.ScaleMode = vbPixels
    picRes.AutoRedraw = True
    picRes.BackColor = vbWhite

    lCount = UBound(aFontCollection)

    ' alle Schriftarten in der FontCollection durchlaufen
    For lItem = 0 To lCount

        ' passt der Name
        If aFontCollection(lItem).sFontName = FontName Then

            ' Font gefunden
            bFontExists = True
            sFontName = aFontCollection(lItem).sFontName

            Exit For

        End If

    Next

    ' Font gefunden
    If bFontExists = True Then

        ' Eigenschaften fr den zu erstellenden Font festlegen
        With tLOGFONT

            Call CopyMemory(ByVal VarPtr(.lfFaceName(0)), ByVal StrPtr(sFontName), _
                Len(sFontName) * 2)

            .lfHeight = -MulDiv(FontSize, GetDeviceCaps(picRes.hDC, _
                LOGPIXELSY), 72)

            .lfCharSet = ANSI_CHARSET
            
            If CBool(eFontStyle And FontStyleBold) = True Or _
                CBool(eFontStyle And FontStyleBoldItalic) = True Then
                .lfWeight = FW_BOLD
            End If
            
            .lfItalic = CBool(eFontStyle And FontStyleItalic)
            .lfStrikeOut = CBool(eFontStyle And FontStyleStrikeout)
            .lfUnderline = CBool(eFontStyle And FontStyleUnderline)
            .lfOutPrecision = OUT_TT_ONLY_PRECIS
            .lfQuality = ANTIALIASED_QUALITY

        End With

        ' einen Font erstellen
        hFont = CreateFontIndirect(tLOGFONT)

        ' ist ein Font vorhanden
        If hFont <> 0 Then

            ' neuen Font in den DC
            hPrevFont = SelectObject(picRes.hDC, hFont)

            ' Text ausgeben
            Call TextOut(picRes.hDC, 10, 10, StrPtr(sText), Len(sText))

            ' alten Font zurck in den DC
            Call SelectObject(picRes.hDC, hPrevFont)

            ' Font lschen
            Call DeleteObject(hFont)

        End If

    End If

End Sub
