Attribute VB_Name = "modFont"
Option Explicit

' ----==== Const ====----
Public Const LOGPIXELSY As Long = 90&
Public Const OUT_TT_ONLY_PRECIS As Long = 7&
Public Const ANTIALIASED_QUALITY As Long = 4&
Public Const LB_ADDSTRING As Long = &H180&
Public Const LF_FACESIZE As Long = 32&
Public Const LF_FULLFACESIZE As Long = 64&
Public Const FW_BOLD As Long = 700&
Public Const ANSI_CHARSET As Long = 0&

' ----==== Enum ====----
Public Enum FR_FLAGS
    FR_DEFAULT = &H0&
    FR_PRIVATE = &H10&
    FR_NOT_ENUM = &H20&
End Enum

Public Enum FontStyle
    FontStyleRegular = &H0
    FontStyleBold = &H1
    FontStyleItalic = &H2
    FontStyleBoldItalic = &H3
    FontStyleUnderline = &H4
    FontStyleStrikeout = &H8
End Enum

' ----==== Types ====----
Public Type NEWTEXTMETRIC
    tmHeight As Long
    tmAscent As Long
    tmDescent As Long
    tmInternalLeading As Long
    tmExternalLeading As Long
    tmAveCharWidth As Long
    tmMaxCharWidth As Long
    tmWeight As Long
    tmOverhang As Long
    tmDigitizedAspectX As Long
    tmDigitizedAspectY As Long
    tmFirstChar As Byte
    tmLastChar As Byte
    tmDefaultChar As Byte
    tmBreakChar As Byte
    tmItalic As Byte
    tmUnderlined As Byte
    tmStruckOut As Byte
    tmPitchAndFamily As Byte
    tmCharSet As Byte
    ntmFlags As Long
    ntmSizeEM As Long
    ntmCellHeight As Long
    ntmAveWidth As Long
End Type

Public Type FONTSIGNATURE
    fsUsb(4) As Long
    fsCsb(2) As Long
End Type

Public Type NEWTEXTMETRICEX
    ntmTm As NEWTEXTMETRIC
    ntmFontSig As FONTSIGNATURE
End Type

Public Type LOGFONTW
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(LF_FACESIZE - 1) As Byte
End Type

Public Type ENUMLOGFONTEX
    elfLogFont As LOGFONTW
    elfFullName(LF_FULLFACESIZE - 1) As Byte
    elfStyle(LF_FACESIZE - 1) As Byte
    elfScript(LF_FACESIZE - 1) As Byte
End Type

' ----==== Kernel32.dll Deklarationen ====----
Public Declare Sub CopyMemory Lib "kernel32.dll" _
                   Alias "RtlMoveMemory" ( _
                   ByRef pDest As Long, _
                   ByRef pSource As Long, _
                   ByVal ByteLen As Long)

Public Declare Function MulDiv Lib "kernel32.dll" ( _
                        ByVal lNumber As Long, _
                        ByVal lNumerator As Long, _
                        ByVal lDenominator As Long) As Long

' ----==== User32.dll Deklarationen ====----
Public Declare Function SendMessageString Lib "user32.dll" _
                        Alias "SendMessageA" ( _
                        ByVal hWnd As Long, _
                        ByVal wMsg As Long, _
                        ByVal wParam As Long, _
                        ByVal lParam As String) As Long

' ----==== Gdi32.dll Deklarationen ====----
Public Declare Function EnumFontFamiliesEx Lib "gdi32.dll" _
                        Alias "EnumFontFamiliesExW" ( _
                        ByVal hDC As Long, _
                        ByRef lpLogFont As LOGFONTW, _
                        ByVal lpEnumFontProc As Long, _
                        ByVal lParam As Long, _
                        ByVal dw As Long) As Long

Public Declare Function GetDeviceCaps Lib "gdi32.dll" ( _
                        ByVal hDC As Long, _
                        ByVal nIndex As Long) As Long

Public Declare Function AddFontMemResourceEx Lib "gdi32.dll" ( _
                        ByVal pFileView As Long, _
                        ByVal cjSize As Long, _
                        ByVal pvResrved As Long, _
                        ByRef pNumFonts As Long) As Long

Public Declare Function RemoveFontMemResourceEx Lib "gdi32.dll" ( _
                        ByVal hFont As Long) As Long

Public Declare Function AddFontResourceEx Lib "gdi32.dll" _
                        Alias "AddFontResourceExW" ( _
                        ByVal lpcstr As Long, _
                        ByVal dword As Long, _
                        ByVal res As Long) As Long

Public Declare Function RemoveFontResourceEx Lib "gdi32.dll" _
                        Alias "RemoveFontResourceExW" ( _
                        ByVal lpcstr As Long, _
                        ByVal dword As Long, _
                        ByVal res As Long) As Long

Public Declare Function CreateFontIndirect Lib "gdi32.dll" _
                        Alias "CreateFontIndirectW" ( _
                        ByRef lpLogFont As LOGFONTW) As Long

Public Declare Function SelectObject Lib "gdi32.dll" ( _
                        ByVal hDC As Long, _
                        ByVal hgdiObj As Long) As Long

Public Declare Function DeleteObject Lib "gdi32.dll" ( _
                        ByVal hgdiObj As Long) As Long

Public Declare Function TextOut Lib "gdi32.dll" _
                        Alias "TextOutW" ( _
                        ByVal hDC As Long, _
                        ByVal x As Long, _
                        ByVal y As Long, _
                        ByVal lpString As Long, _
                        ByVal nCount As Long) As Long

' ----==== Ole32.dll Deklarationen ====----
Public Declare Sub CoTaskMemFree Lib "ole32.dll" ( _
                   ByVal pMem As Long)

Public Declare Function CoTaskMemAlloc Lib "ole32.dll" ( _
                        ByVal cb As Long) As Long

' ----==== Oleaut32.dll Deklarationen ====----
Public Declare Function SafeArrayGetDim Lib "oleaut32.dll" ( _
                        ByRef pArray() As Any) As Long

' ----==== Shlwapi.dll Deklarationen ====----
Public Declare Function PathFileExistsW Lib "Shlwapi.dll" ( _
                        ByVal pszFile As Long) As Long

Public Function EnumFontFamiliesExProc(ByRef lpelfe As ENUMLOGFONTEX, ByRef lpntme _
    As NEWTEXTMETRICEX, ByVal FontType As Long, ByVal lParam As Long) As Long

    Dim strFontName As String
    Dim lPos As Long

    strFontName = CStr(lpelfe.elfLogFont.lfFaceName)

    lPos = InStr(1, strFontName, vbNullChar)

    If lPos > 0 Then

        strFontName = Mid$(strFontName, 1, lPos - 1)

    End If

    Call SendMessageString(lParam, LB_ADDSTRING, 0, strFontName)

    EnumFontFamiliesExProc = 1&

End Function
